import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;

public class MyArrayList<T> {
    private T[] currentArray;
    static final int DEFAULT_CAPACITY = 99;

    public int getCapacity() {
        return capacity;
    }

    private int capacity;
    private int size;

    public MyArrayList() {
        this(DEFAULT_CAPACITY);
    }

    public MyArrayList(int capacity) {
        this.capacity = capacity;
        this.currentArray = (T[]) new Object[capacity];
        size = 0;
    }

    public void add(T t) throws IndexOutOfBoundsException{
        if (size == capacity) {
            throw new IndexOutOfBoundsException("Capacity exceeded");
        }
        currentArray[size] = t;
        size++;
    }

    public T get(int index) {
        if (index < 0 || index >= this.size) throw new IndexOutOfBoundsException("Index out of bounds");
        return currentArray[index];
    }

    public T set(int index, T t) {
        T oldValue = currentArray[index];
        currentArray[index] = t;
        return oldValue;
    }

    public void clear() {
        size = 0;
    }

    public boolean isEmpty() {
        if (size == 0) return true;
        else return false;
    }

    public boolean contains(T t) {
        for (int i = 0; i < size; i++) {
            if (t.equals(currentArray[i])) return true;
        }
        return false;
    }

    public int size() {
        return size;
    }

    public T[] toArray() {
        T[] newArray = (T[]) new Object[size];
        for (int i = 0; i < size; i++) {
            newArray[i] = currentArray[i];
        }
        return newArray;
    }

    public T[] toArray(T[] arr) {
        for (int i = 0; i < size; i++) {
            arr[i] = currentArray[i];
        }
        return arr;
    }

    public void remove(int index) throws IndexOutOfBoundsException{
        if (index >= this.size || index < 0) {
            throw new IndexOutOfBoundsException("Index out of bounds");
        }
        for (int i = index; i < size; i++) {
            set(i, currentArray[i+1]);
        }
        size--;
    }

}