public class MyMap<K, V> {
    private final MySet<K> key;
    private final MyArrayList<V> value;
    private static final int DEFAULT_CAPACITY = 99;

    public MyMap(int capacity) {
        this.key = new MySet<>(capacity);
        this.value = new MyArrayList<>(capacity);
    }

    public MyMap() {
        this.key = new MySet<>(DEFAULT_CAPACITY);
        this.value = new MyArrayList<>(DEFAULT_CAPACITY);
    }

    public void clear() {
        key.clear();
        value.clear();
    }

    public boolean containsKey(K key) {
        return this.key.contains(key);
    }

    public boolean containsValue(V value) {
        return this.value.contains(value);
    }

    public V get(K key) {
        int index = this.key.find(key);
        return this.value.get(index);
    }

    public boolean isEmpty() {
        return value.isEmpty() && key.isEmpty();
    }

    public void put(K key, V value) {
        this.key.add(key);
        this.value.add(value);
    }

    public void putAll(MyMap<K,V> m) {
        for (int i = 0; i < m.size(); i++) {
            this.key.add(m.keySet().get(i));
            this.value.add(m.valueSet().get(i));
        }
    }

    public V remove(K key) {
        int i = this.key.find(key);
        V value = valueSet().get(i);
        keySet().remove(i);
        valueSet().remove(i);
        return value;
    }

    public int size() {
        return keySet().size();
    }

    public MySet<K> keySet() {
        return key;
    }

    public MyArrayList<V> valueSet() {
        return value;
    }

}
