import org.omg.CORBA.OBJECT_NOT_EXIST;

public class MySet<T> {
    private static final int DEFAULT_CAPACITY = 99;
    private final MyArrayList<T> key;

    public MySet(int capacity) {
        this.key = new MyArrayList<>(capacity);
    }

    public MySet() {
        this(DEFAULT_CAPACITY);
    }

    public void add(T t) {
        if (this.contains(t)) { throw new IllegalStateException("No repeat numbers allowed!"); }
        else { key.add(t); }
    }

    public void addAll(MyArrayList<? extends T> a) {
        if (key.size() + a.size() == key.getCapacity()) {
            throw new IndexOutOfBoundsException("Capacity exceeded");
        }
        for (int i = 0; i < a.size(); i++) {
            if (contains(a.get(i))) {
                throw new IllegalStateException("No repeat numbers allowed");
            } else {
                this.add(a.get(i));
            }
        }
    }

    public T get(int index) {
        return key.get(index);
    }

    public void clear() {
        key.clear();
    }

    public boolean contains(T t) {
        for (int i = 0; i <key.size(); i++) {
            if (key.get(i).equals(t)) {
                return true;
            }
        }
        return false;
    }

    public boolean containsAll(T ... t) {
        for (T obj : t) {
            if (!contains(obj)) {
                return false;
            }
        }
        return true;
    }

    public boolean containsAll(MyArrayList<T> t) {
        for (int i = 0; i < t.size(); i++) {
            if (!contains(t.get(i))) {
                return false;
            }
        }
        return true;
    }

    public void remove(int index) {
        key.remove(index);
    }

    public int size() {
        return key.size();
    }

    public int find(T t) throws OBJECT_NOT_EXIST {
        for (int i = 0; i < key.size(); i++) {
            if (t.equals(key.get(i))) {
                return i;
            }
        }
        throw new OBJECT_NOT_EXIST("Object not found in this set");
    }

    public boolean isEmpty() {
        return key.isEmpty();
    }
}
