import org.junit.Assert;
import org.junit.Test;

import static org.junit.Assert.*;

public class MyArrayListTest {
    MyArrayList<String> arrString = new MyArrayList<>();
    MyArrayList<Integer> arrInteger = new MyArrayList<>();


    @Test
    public void add() {
        arrString.add("stuff");

        String expected = "stuff";
        String actual = arrString.get(0);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void get() {
        arrInteger.add(6);

        Object expected = 6;
        Object actual = arrInteger.get(0);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void set() {
        arrInteger.add(6);

        Object actual = arrInteger.set(0, 3);
        Object expected = 6;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void set2() {
        arrInteger.add(6);

        arrInteger.set(0, 3);
        Object actual = arrInteger.get(0);
        Object expected = 3;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void clear() {
        arrInteger.add(6);

        arrInteger.clear();
        boolean actual = arrInteger.isEmpty();

        Assert.assertTrue(actual);
    }

    @Test
    public void clear0() {
        arrInteger.add(6);

        boolean actual = !arrInteger.isEmpty();

        Assert.assertTrue(actual);
    }

    @Test
    public void contains() {
        arrInteger.add(6);

        boolean actual = arrInteger.contains(6);

        Assert.assertTrue(actual);
    }

    @Test
    public void contains0() {
        arrInteger.add(3);

        boolean actual = !arrInteger.contains(6);

        Assert.assertTrue(actual);
    }

    @Test
    public void size() {
        arrInteger.add(3);
        arrInteger.add(6);

        int actual = arrInteger.size();
        int expected = 2;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void toArray() {
        arrInteger.add(3);
        arrInteger.add(6);

        Object[] arrNew = arrInteger.toArray();

        Assert.assertEquals(3, arrNew[0]);
        Assert.assertEquals(6, arrNew[1]);
    }

    @Test
    public void toArray1() {
        arrInteger.add(3);
        arrInteger.add(6);

        Integer[] arrNew = arrInteger.toArray(new Integer[2]);

        Integer expected = 3;
        Integer actual = arrNew[0];

        Integer expected1 = 6;
        Integer actual1 = arrNew[1];

        Assert.assertEquals(expected, actual);
        Assert.assertEquals(expected1, actual1);
    }

    @Test
    public void remove() {
        arrInteger.add(3);
        arrInteger.add(6);

        arrInteger.remove(0);
        Integer actual = arrInteger.get(0);
        Integer expected = 6;

        Assert.assertEquals(expected,actual);
    }

}