import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

public class MyMapTest {
    MyMap<Object,Object> myMap = new MyMap<>();

    @Before public void setup(){
        myMap.put(1,"one");
        myMap.put(2,"two");
        myMap.put(3,"three");
    }

    @Test
    public void clear() {
        myMap.clear();

        int expected = 0;
        int actual = myMap.size();

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void containsKey() {
        boolean actual = myMap.containsKey(3);

        Assert.assertTrue(actual);
    }

    @Test
    public void containsKey1() {
        boolean actual = myMap.containsKey(9);

        Assert.assertFalse(actual);
    }

    @Test
    public void containsValue() {
        boolean actual = myMap.containsValue("one");

        Assert.assertTrue(actual);
    }

    @Test
    public void containsValue1() {
        boolean actual = myMap.containsValue("butt");

        Assert.assertFalse(actual);
    }

    @Test
    public void get() {
        Object actual = myMap.get(1);
        Object expected = "one";

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void isEmpty() {
        boolean actual = myMap.isEmpty();

        Assert.assertFalse(actual);
    }

    @Test
    public void isEmpty1() {
        myMap.clear();

        boolean actual = myMap.isEmpty();

        Assert.assertTrue(actual);
    }

    @Test
    public void put() {
        myMap.put(4,"four");

        Assert.assertNotNull(myMap.get(4));
    }

    @Test
    public void putAll() {
        MyMap<Object,Object> myOtherMap;

        myOtherMap = new MyMap<>();
        myOtherMap.putAll(myMap);

        Assert.assertEquals(myMap.get(1),myOtherMap.get(1));
        Assert.assertEquals(myMap.get(3),myOtherMap.get(3));

    }

    @Test
    public void remove() {
        myMap.remove(2);

        int actual = myMap.size();
        int expected = 2;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void size() {
        int actual = myMap.size();
        int expected = 3;

        Assert.assertEquals(expected,actual);
    }
}