import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class MySetTest {
    MySet<Object> set = new MySet<>();

    @Test
    public void add() {
        set.add("thing");
        Assert.assertNotNull(set.get(0));
    }

    @Test (expected = IllegalStateException.class)
    public void add1() {
        set.add("thing");
        set.add("thing");
    }

    @Test
    public void addAll() {
        MyArrayList<Object> myArr = new MyArrayList<>(3);
        myArr.add("WHAT");
        myArr.add("THE");
        myArr.add("HECK");

        set.addAll(myArr);
        Object actual = set.get(2);
        Object expected = "HECK";

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void clear() {
        set.add("thing1");
        set.add("thing2");

        set.clear();

        Assert.assertFalse(set.contains("thing1"));
    }

    @Test
    public void contains() {
        set.add("thing1");
        set.add("thing2");

        Assert.assertTrue(set.contains("thing1"));
    }

    MyArrayList<Object> myArr = new MyArrayList<>(3);

    @Before
    public void setup() {
        myArr.add("WHAT");
        myArr.add("THE");
        myArr.add("HECK");
    }

    @Test
    public void remove() {

        set.addAll(myArr);
        set.remove(1);
        Object actual = set.get(1);
        Object expected = "HECK";

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void size() {
        set.add("thing1");
        set.add("thing2");

        int actual = set.size();
        int expected = 2;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void containsAll() {
        set.addAll(myArr);

        Assert.assertTrue(set.containsAll(myArr));
    }

    @Test
    public void containsAll1() {
        set.addAll(myArr);

        Assert.assertTrue(set.containsAll("WHAT", "THE", "HECK"));
    }
}